#ifndef __windows_inc__
#include "windows.inc"
#endif

#define TOKEN_STRING  0x00000001
#define TOKEN_COMMENT 0x00000002
#define TOKEN_OPERAND 0x00000004
#define TOKEN_NEWLINE 0x00000008
#define TOKEN_KEYWORD 0x00000010
#define TOKEN_INTEGER 0x00000020
#define TOKEN_HEX     0x00000040 | TOKEN_INTEGER
#define TOKEN_SPACE   0x00000080
#define TOKEN_TAB     0x00000100
#define TOKEN_PREPROC 0x00000200
#define TOKEN_CHAR    0x00000400 // 'a'
#define TOKEN_IGNORE  0x00000800 // [set by application]
#define TOKEN_MAX     0x000007FF
#define TOKEN_DELETE  0x80000000 // [set by application] if set, FreeTokens should call delete text

#ifndef _tokenizer_
declare extern _findchar(unsigned byte *bRefArray, int count, unsigned byte find),BOOL;
declare extern _findword(unsigned word *wRefArray, int count, unsigned word find),BOOL;
//declare extern CreateRootToken(int type, string *text, int textlen),token *;
#endif

const TOKEN_WHITESPACE = TOKEN_SPACE | TOKEN_TAB | TOKEN_NEWLINE;
const TOKEN_SPACE_TAB = TOKEN_SPACE | TOKEN_TAB;
const TOKEN_WHITESPACE_COMMENT = TOKEN_WHITESPACE | TOKEN_COMMENT;

struct token {
	token  *next;
//	token  *prev;
	int     type;
	string *text; // points to raw data (not null terminated strings)
	int     textlen;
	int     linenum;
//	void   *userdata;
}


///////////////////////////////////////////////////////////////////////////////////

class CTokenizer
{
	declare CTokenizer();
	declare _CTokenizer();
	declare Tokenize(string *pInput, BOOL fEbasic, BOOL fPlainText),BOOL;
	declare GetTokens(token *ppToken),BOOL; // ok
	declare FreeTokens();
	declare SetError(string *szError, opt BOOL bRetval),BOOL; // ok
	declare GetError(opt void *ppszError),pointer;
	declare GetByte(byte *lpddress),byte; // to handle line numbers

	// add any new variables to CTokenizer :: CTokenizer() in memset(this+4, 0, 4*11);
	token         *m_token;
	BYTE          *m_pInvalid;
}
///////////////////////////////////////////////////////////////////////////////////



