#ifndef __CSplitter2_inc__
#define __CSplitter2_inc__

#ifndef __windows_inc__
#include "windows.inc"
#endif

const SPSIZE = 7;


enum SPLITTERSTYLE
{
	SPLITTERSTYLE_LEFT   = 0x1, // base styles, passed to CreateSplitterWindow
	SPLITTERSTYLE_TOP    = 0x2,
	SPLITTERSTYLE_RIGHT  = 0x4,
	SPLITTERSTYLE_BOTTOM = 0x8,
//private
	SPLITTERSTYLE_LR         = 0x5, // used to detect if SPLITTERSTYLE_LEFT or SPLITTERSTYLE_RIGHT was set
	SPLITTERSTYLE_UD         = 0xA, // used to detect if SPLITTERSTYLE_TOP or SPLITTERSTYLE_BOTTOM was set
	SPLITTERSTYLE_MASK       = 0xF,  // used to extract four base flags: left, top, right and bottom
	SPLITTERSTYLE_HORIZONTAL = 0x10, // top / bottom windows;  this (or next) style is always present
	SPLITTERSTYLE_VERTICAL   = 0x20, // left / right windows;  this (or previous) style is always present
	SPLITTERSTYLE_HVMASK     = 0x30  // used to detect if SPLITTERSTYLE_HORIZONTAL or SPLITTERSTYLE_VERTICAL was set
}
class CSplitter
{
	declare virtual OnResized(int cx,int cy);
	declare virtual WndProc(UINT uMsg,WPARAM wParam,LPARAM lParam),BOOL;
	declare Resize(int cx,int cy);  // first:fit width/height; second: fit client
	declare Resize2(int cx,int cy); // second:fit width/height; first: fit client
	declare GetRealClientRect(RECT *rc);

// private
	declare OnSize(int cx,int cy); // resize drag-button and child splitters, if any
	declare OnButtonPaint(PAINTSTRUCT *pds);
	declare OnLButtonDown(int x,int y);
	declare OnMouseMove(int x,int y);
	declare OnLButtonUp(int x,int y);
	declare DrawSplitter();

	HWND       m_hwnd;
	HWND       m_hwndDrag; // drag button
	HWND       m_hwndClip; // parent window, the splitted window
	SPLITTERSTYLE m_style;
	HBRUSH     m_hbr;
	HBITMAP    m_hbm;
	POINT      m_ptSplStart; // where in the splitter button the mouse was down
	POINT      m_ptSplpos;   // current cursor position while dragging
	HCURSOR    m_crsSize;
	CSplitter *m_pResize;  // pointer to second window. Splitted window has two child windows (dialogs).
	CSplitter *m_pChild;   // pointer to child splitter. Splitter can be splited by another splitter.
}


#ifndef __CSplitter2_src__
// create spliter from user dalogs
declare extern CreateSplitterWindowEx(
	HINSTANCE  hInst,
	HWND       parent,
	int        wh,
	CSplitter* sp1,
	LPTSTR     lpTemplateName1,
	CSplitter* sp2,
	LPTSTR     lpTemplateName2);

#endif

#endif


