// http://support.microsoft.com/kb/175513/en-us
//Invoke Find, View Source, Options Dialog Boxes for WebBrowser
//extern _CGID_IWebBrowser as GUID; // {ED016940-BD5B-11CF-BA4E-00C04FD70816}
#define HTMLID_FIND 1
#define HTMLID_VIEWSOURCE 2
#define HTMLID_OPTIONS 3

// undefined clipboard formats
#define CFSTR_UNTRUSTEDDRAGDROP L"UntrustedDragDrop"
#define CFSTR_SHELLHOOK         L"SHELLHOOK"
#define CFSTR_TASKBARCREATED    L"TaskbarCreated"

// undocumented constants
#define STARTF_TITLESHORTCUT	0x800
const MAX_PATHW = MAX_PATH*2;

// create MDI as child of the tab control
//#define MDI_ON_TAB

#include "CSplitter.inc"
#include "resource.inc"
#include "dropsource.inc"
#include "commctrl.inc"
#include "CWebPage.inc"
#include "ocx\\MSHelpServices.inc"
#include "ocx\\MSHelpControls.inc"
#include "exdisp.inc"        // IWebBrowser2

// registry
// "Hook dll name"    = [default] "HtmlHelpHook.dll"
// "Hook type"        = [default] "mouse" or "keyboard"
// "Hide when closed" = [REG_DWORD][BOOL]
// "Hide on startup"

// MENU id's
// 10000 - 10999 -> main window menu
// 11000 - 11999 -> browser list; popup in main menu
// 12000 - 
// 51000 - ?     -> hooked applications window list

// script error in keyword 'lpValue field' in namespace ms.msdm.v80

// DEFINES
// #define SHOW_FULL_TITLE_IN_TAB
const TAB_LABEL_TEXT_WIDTH_MAX = 110; // valid if SHOW_FULL_TITLE_IN_TAB not defined

//==============================================
//#define HOOKLOADERROR_WARNING // show error message when initialization fails to load hook-dll


// come or'ed constants
const LVEXSTYLE   = LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP;
const WS_MDIFRAME = WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN;
const WS_MDICHILD = WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN;// | WS_MAXIMIZE;
const WM_TRAY     = WM_USER|45;

const CBN_NAMESPACECHANGED   = IDC_NAMESPACES | (CBN_SELCHANGE<<16);
const CBN_FILTERCHANGED      = IDC_FILTERS | (CBN_SELCHANGE<<16);
const CBN_EDITKEYWORDCHANGE  = IDC_KEYWORDS | (CBN_EDITCHANGE<<16);
const CBN_COMBOKEYWORDCHANGE = IDC_KEYWORDS | (CBN_SELCHANGE<<16);
const CBN_URLSELCHANGED      = IDC_CBO1 | (CBN_SELCHANGE<<16);


const NIF_ICON_MESSAGE_TIP         = NIF_ICON|NIF_MESSAGE|NIF_TIP;
const MF_BYCOMMAND_CHECKED         = MF_BYCOMMAND | MF_CHECKED;
const MIIM_DATA_TYPE_ID            = MIIM_DATA | MIIM_TYPE | MIIM_ID;
const LVCF_TEXT_WIDTH              = LVCF_TEXT | LVCF_WIDTH;
const DROPEFFECT_COPY_LINK         = DROPEFFECT_COPY | DROPEFFECT_LINK;
const LVIS_SELECTED_FOCUSED        = LVIS_SELECTED | LVIS_FOCUSED;
const TCIF_PARAM_TEXT              = TCIF_PARAM | TCIF_TEXT;
const SWP_SHOWWINDOW_DRAWFRAME     = SWP_SHOWWINDOW | SWP_DRAWFRAME;
const LR_LOADMAP3DCOLORS_CREATEDIB = LR_LOADMAP3DCOLORS | LR_CREATEDIBSECTION;
const CDIS_HOT_SELECTED            = CDIS_HOT | CDIS_SELECTED;
const WS_POPUP_BORDER              = WS_POPUP|WS_BORDER;
const WS_POPUP_VISIBLE_BORDER      = WS_POPUP | WS_VISIBLE | WS_BORDER;
const SWP_SHOWWINDOW_DRAWFRAME     = SWP_SHOWWINDOW|SWP_DRAWFRAME;
const KEY_READ_WRITE               = KEY_READ | KEY_WRITE;



/*
sub CControlBase
*/
class CControlBase
{
	declare SendMessage(UINT uMsg, WPARAM wParam, LPARAM lParam),LRESULT;
	declare Hide();
	HWND   m_hwnd;
}


/*
sub CAutoSuggest
*/
// helper class that is capable to show a resizable popup listbox
// when you click a topic with multiple subtopics, it will pop up
class CAutoSuggest : CControlBase
{
	declare Initialize(HWND hwnd);
	declare Add(WCHAR *title, IHxTopic *topic);
	// Show() will return selected IHxTopic *
	declare Show(HWND hwndRef, int left,int top,int nItems),IHxTopic *;

	int  m_TextWidth;
}

/*
sub CSettings
*/
// helper to access private registry settings
// the actual registry path is defined as SZ_REG_ROOT_PATHA (common.inc)
class CSettings
{
	declare CSettings();
	declare _CSettings();
	declare OpenKey(),BOOL;

//	declare ReadStringA(LPSTR name, LPSTR value,int cch,opt LPSTR pDefault=0),BOOL;
	declare ReadStringW(LPWSTR name, LPWSTR value,int cch,opt LPWSTR pDefault=0),BOOL;
//	declare WriteStringA(LPSTR name, LPSTR value),BOOL;
	declare WriteStringW(LPWSTR name, LPWSTR value),BOOL;

	declare ReadDWORD(LPSTR name, DWORD DefaultValue),DWORD;
	declare WriteDWORD(LPSTR name, DWORD value),BOOL;

//	declare DeleteValueA(LPSTR name);
	declare DeleteValueW(LPWSTR name);

	HKEY    m_hk;
}



/*
sub REGHOOK
*/
// hook information [linked list]
struct REGHOOK
{
	HWND   WindowHandle; // to retrieve window title and check if running
	DWORD  ProcessId;
	DWORD  ThreadId;
	HHOOK  HookHandle;
	BOOL   IsAurora;
}

/*
sub CHookList
*/
class CHookList : CPointerList
{
	declare  CHookList();
	declare _CHookList();
	declare AddNew(HWND WindowHandle, DWORD ProcessId, DWORD ThreadId,BOOL IsAurora),REGHOOK *;
	declare LookupHookHandleByThreadId(DWORD ThreadID),HHOOK;
	declare Unhook(_linked_list *pos);
	declare UnhookAll();
	// scanning
	declare ScanProcesses();
	declare EnumModules(DWORD pid);

	DWORD   m_HookType; // WH_MOUSE ...
	FARPROC m_HookProc; // GetProcAddress
	HMODULE m_HookModule;
	int     m_count;
}

/*
sub CCommandTarget
*/
// this interface will be added to webbrowser core [_g_webpageextension] to disable script error debugging
// I don't know why, but it should be disabled before calling _EmbedBrowserObject()
// ** already added 'disabler' to cwebpage.c
class CCommandTarget : CUnknown
{
	declare virtual QueryInterface(GUID *iid,void *ppvObject),HRESULT;
	declare virtual QueryStatus(GUID *pguidCmdGroup, ULONG cCmds, OLECMD *prgCmds, OLECMDTEXT *pCmdText),HRESULT;
	declare virtual Exec(GUID *pguidCmdGroup,DWORD nCmdID, DWORD nCmdexecopt, VARIANT *pvaIn,VARIANT *pvaOut),HRESULT;
}

/*
sub CDispatch
*/
class CDispatch : CUnknown
{
	declare CDispatch();
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual GetTypeInfoCount(UINT *pctinfo),HRESULT;
	declare virtual GetTypeInfo(UINT iTInfo, LCID lcid, ITypeInfo *ppTInfo),HRESULT;
	declare virtual GetIDsOfNames(REFIID *riid, LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgDispId),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr),HRESULT;

	declare Advise(IUnknown *object, REFIID *riid),HRESULT;
	declare Unadvise(),HRESULT;

	GUID      m_adviseIID;
	DWORD     m_adviseCookie;
	IUnknown *m_adviseObject;
}

/*
sub DHxIndexViewEvents
*/
class DHxIndexViewEvents : CDispatch // [dispatchable]
{
//	declare virtual QueryInterface(GUID *iid,void *ppvObject),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr),HRESULT;
	// 0x00002000
	declare virtual NodeClick(long hNode);
	// 0x00002003
	declare virtual NodeRightClick(long hNode, long x, long y);
//	DWORD m_cookie;
	HWND  m_hwnd;
}

/*
sub DHxSessionEvents
*/
class DHxSessionEvents : CDispatch // [dispatchable]
{
//	declare virtual QueryInterface(GUID *iid,void *ppvObject),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr),HRESULT;
	// 0x00010108
	declare virtual QueryCancel(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status);
	// 0x00010109
	declare virtual IndexMergeStatus(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status);
	// 0x0001010a
	declare virtual PrintMergeStatus(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status);
	// 0x0001010c
	declare virtual MergeIndexFileName(/*[in]*/IDispatch* pDisp, /*[in]*/BSTR bstrFile);
//	DWORD m_cookie;
}

/*
sub CDispBrowser
*/
// IDispatch implementation that will receive notifications from the browser
class CDispBrowser : CDispatch
{
	// TODO: move the code <reindex m_TabIndex after closing a browser>
	// from OnDestroy() to another class
//	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr),HRESULT;
	declare Navigate(WCHAR* pUrl);
	// this method is safe [this can be NULL]
	declare ExecHtmlDispId(DISPID id);
	// create browser control, advise callback, add browser to focus history head
	declare OnCreate(HWND hwnd, CREATESTRUCT *cs),int;
	// resize browser to fit CWorkerBrowser::m_hwndMdi, update toolbar buttons and URL,
	//  move current browser to focus history head, select a tab in tab control
	declare OnActivated(WINDOWPOS *pos);
	// remove browser from focus history
	declare OnDestroy();

	HWND  m_hwnd;           // MdiChildWndProc()  created in CWorkerBrowser::CreateBrowser()
	HWND  m_hwndOle;        // used for WM_MOUSEWHEEL handler in CApp::MessageLoop
//	DWORD m_cookie;         // DWebBrowserEvents2 cookie
	BOOL  m_BackEnabled;    // need to save state while using multiple browsers
	BOOL  m_ForwardEnabled; // need to save state while using multiple browsers
	int   m_TabIndex;       // index of tab in tab control

	IWebBrowser2 *m_webbrowser;
}



// a helper for managing browser focus history; accesible from global variable <BrowserManager>
// Every created browser is added to the list head, is also focused/activated.
// When you select another browser from menu, call ActivateBrowser to show it and
// move its pointer to the focus list head.
// When you close a browser, call RemoveBrowser to remove it from the list, and
// activate the recently visible browser.
// Only the active browser is visible, other are hidden. The browser's WndProc should detect
//   WM_WINDOWPOSCHANGING with flag SWP_SHOWWINDOW - update toolbar buttons
//   WM_DESTROY - should RemoveBrowser


/*
sub _browser_list
*/
struct _browser_list
{
	_browser_list *next;
	CDispBrowser  *data;
}

/*
sub CBrowserManager
*/
class CBrowserManager
{
	// hide current, show new
	declare AddBrowser(CDispBrowser *browser),BOOL;
	// hide browser, show first
	declare RemoveBrowser(CDispBrowser *browser);
	// hide current, show browser
	declare ActivateBrowser(CDispBrowser *browser, opt BOOL show=true);
	declare IsEmpty(),BOOL;

	_browser_list *m_list;
}








/* right pane with toolbar, tab control, browser(s) and a worker window <MDIHOST>
   The MDIHOST/MDICHILD are custom window classes
sub CWorkerBrowser
*/
class CWorkerBrowser : CSplitter
{
	declare virtual OnResized(int cx,int cy);
	declare virtual WndProc(UINT uMsg,WPARAM wParam,LPARAM lParam),BOOL;
	declare OnInitDialog();
	declare InitializeMDI();
	// insert buttons, load button images, create gray image
//	declare InitializeToolbar();
	declare OnClose();
	// call OnRClick/OnTabSelChanged/OnDrawToolbar/GetTooltipText
	declare OnNotify(NMHDR *pnmhdr);
	// handle toolbar buttons and IDOK from URL combo
	declare OnCommand(WPARAM wParam);
	// show context menu for tab control items
	declare OnRClick(NMHDR *pnmhdr);
	// switch to another browser
	declare OnTabSelChanged();
	declare OnDrawToolbar(NMTBCUSTOMDRAW *nmtbcd);
	// handle TTN_GETDISPINFO
	declare GetTooltipText(NMTTDISPINFO *pttdi);

	declare CreateBrowser(),CDispBrowser *;
	declare GetActiveBrowser(opt BOOL CreateIfNone=0),CDispBrowser *;
	declare GetCurrentWebBrowser(),IWebBrowser2 *; // return active CDispBrowser, or create new if none
	declare QueryHtmlDispId(IWebBrowser2 *webbrowser, OLECMDID cmdID, OLECMDF *pcmdf),HRESULT;
	// Navigate will reuse current browser, or create new if none
	declare Navigate(WCHAR* pUrl);
	declare GetIdealBrowserRect(RECT *prc);
	declare RedrawTabControl();

	CCommandTarget m_cmdt;
	// MDI
	HWND m_hwndMdi; // custom window - MdiHostWndProc()
}


/*
sub CDropTarget
*/
// helper allowing dropping text {from browser} to 'Look for' editbox
class CDropTarget : CUnknown
{
	declare virtual QueryInterface(REFIID *riid,void *ppvObject),HRESULT;
	declare virtual DragEnter(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;
	declare virtual DragOver(DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;
	declare virtual DragLeave(),HRESULT;
	declare virtual Drop(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt byval,DWORD *pdwEffect),HRESULT;

	FORMATETC    m_fmtText;
	FORMATETC    m_fmtUrl;
	HWND         m_hwndTarget;
	int          m_itemIndex;
	IDataObject *m_do;
//	IDropTargetHelper *m_helper;
}

// ===================================================


/*
sub CWorkerTopics
*/
// left pane with topic list
class CWorkerTopics : CSplitter
{
	// combobox(m_hwndFilters).item.data = BSTR filter.query
	// CSplitter
	declare virtual OnResized(int cx,int cy);
	declare virtual WndProc(UINT uMsg,WPARAM wParam,LPARAM lParam),BOOL;

	// worker
	declare OnInitDialog();
	declare OnClose();
	declare OnCommand(WPARAM wParam);
	declare OnNotify(NMHDR *pnmhdr);
	declare ShowTopicsContextMenu(NMITEMACTIVATE *pnmia);
	// listview dragdrop
	declare OnTopicBeginDrag(NMLISTVIEW *pnmlv);
	// session
	declare CreateSession(WCHAR *pszNamespace),HRESULT;
	declare ReleaseSession();
	// topics - a topic must belong to active session
	declare AttachTopic(IHxTopic *topic);
	declare ReleaseTopic();
	declare GetTopicText(NMLVDISPINFO *pnmdi);
	// the user selected another namespace
	declare OnNamespaceChanged();
	// the user selected another filter
	declare OnFilterChanged();
	// the user selected another keyword from the list
	declare OnKeywordChanged(),BOOL;
	// user typed a keyword and pressed ENTER
	declare OnTypedKeywordAccepted();
	// scroll the topic list to specified position
	declare SetTopIndex(int item);
	// returns index of first visible topic
	declare GetTopIndex(),int;
	// marks a topic as selected
	declare SelectItem(int item);
	// finds the index of first matching keyword
	declare FindKeywordIndex(WCHAR *szKeyword, BOOL *pFound),int;
	// navigates the browser to a keyword by index
	declare NavigateToItem(int index);
	//
	declare ShowTopicProperties();

	declare EnumNamespaces(),BOOL;
	declare SelectNamespace(wstring Name),BOOL;
	declare EnumFilters();
	declare SelectFilter(wstring *Name),BOOL;
	declare DeleteFilters();
	declare EnumTopics(),HRESULT;
	declare NavigateToDefaultPage();

	// added 2009.03.03
	declare OnTabSelChange();
	declare NavigateToTreeItem(long hNode);
	declare BeginDrag(BSTR bstrTitle,BSTR bstrUrl);
	declare OnTreeBeginDrag(long hNode);
	// added 2009.03.04
	declare SynchronizeTopic();
	//
	// look at http://msdn.microsoft.com/en-us/library/bb164963(VS.80).aspx [Implementing Named URL Indexes]
	// szItemMoniker: one of !DefaultToc !DefaultKeywordIndex !DefaultAssociativeIndex
	//                       !DefaultContextWindowIndex !DefaultNamedUrlIndex
	// szKeyword
	declare LookupKeywordUrl(wstring szNamespace, wstring szKeyword, wstring szItemMoniker, BSTR bstrFilterMoniker, BSTR *ppUrl, IHxTopic *ppTopic),HRESULT;
	declare GetSelectedFilter(),BSTR;

	HWND m_hwndKeywords;     // keywords combobox
	HWND m_hwndKeywordsEdit; // combo's editbox
	HWND m_hwndFilters;      // filters combobox
	HWND m_hwndNamespaces;   // namespaces combobox
	HWND m_hwndTopics;       // topic list listview
	HWND m_hwndSuggest;      // popup with subtopics

	// selected and navigated to topic, set in NavigateToItem(),
	// used in LookupKeywordUrl() if more topics found
	int         m_ActiveTopicIndex;
	
	IHxIndex   *m_index;
	IHxTopic   *m_topic;   // current topic; set in AttachTopic()
	IHxSession *m_session; // m_topic must be from this session
	dwstring    m_szNamespace[128];
	BSTR        m_bstrFilter; // do not free, this is a copy from m_hwndFilters.selected.itemdata
	CAutoSuggest m_autosuggest;
	CDropSource  m_lvDropSource;
	// added 2009.03.03
	HWND m_hwndTree;
	HWND m_hwndTab;
	IHxHierarchy *m_hierarchy;
	IHxTreeView *m_hxtree;
	DHxIndexViewEvents m_hxtreeevents;
	// added 2009.03.08
	DHxSessionEvents m_sessionevets;
}


/*
sub CApp
*/
// application implementation
class CApp : CControlBase
{
	declare WndProc(UINT uMsg,WPARAM wParam,LPARAM lParam),BOOL;
	// wait for and process messages, translate accelerators,
	// handle mouse wheel and special keys
	declare MessageLoop();
	declare ToggleFullScreen();
	declare OnInitDialog();
	declare OnActivate(WPARAM wParam,LPARAM lParam);
	declare InitializeWindowPosition(CSettings settings);
	declare InitializeHook(CSettings settings),BOOL;
	declare InitializeTrayIcon(CSettings settings);
	declare OnInitMenu();
	declare OnCommand(WPARAM wParam, LPARAM lParam);
	declare OnShellHook(WPARAM wParam,LPARAM lParam);
	declare OnSize(int cx, int cy);
	declare OnClose(BOOL force);
	declare OnTray(int uMsg);
	declare OnCopyData(COPYDATASTRUCT *data);

	declare Terminate(); // close
	declare CreateTrayMenu(),HMENU;
//	declare ProcessMessages();

	// menu methods: invoked by a single call from CApp::OnCommand
	// File menu methods; start id: 10001 [IDM_SAVEAS]
	declare virtual MenuSaveAs();
	declare virtual MenuPrint();
	declare virtual MenuPrintPreview();
	declare virtual MenuPageSetup();
	declare virtual MenuProperties();
	declare virtual MenuExit();
	// Edit menu methods; start id: 10007 [IDM_UNDO]
	declare virtual MenuUndo();
	declare virtual MenuRedo();
	declare virtual MenuCut();
	declare virtual MenuCopy();
	declare virtual MenuPaste();
	declare virtual MenuDelete();
	declare virtual MenuSelectAll();
	declare virtual MenuFind();
	declare virtual MenuShowSource();
	// View menu methods; start id: 10016 [IDM_SHOWTOPICPROPS]
	declare virtual MenuShowTopicProperties();
	declare virtual MenuShowNamespaceProperties();
	declare virtual MenuTextSizeLargest();
	declare virtual MenuTextSizeLarger();
	declare virtual MenuTextSizeMedium();
	declare virtual MenuTextSizeSmaller();
	declare virtual MenuTextSizeSmallest();
	declare virtual MenuHide();
	// Options menu methods
	declare virtual MenuPreferences();
	declare virtual MenuInternetOptions();
	// Web Browser menu methods
	declare virtual MenuNewBrowser();
	declare virtual MenuGoBack();
	declare virtual MenuGoForward();
	declare virtual MenuGoStop();
	declare virtual MenuGoRefresh();
	declare virtual MenuGoHome();
	declare virtual MenuGoSearch();
	declare virtual MenuSynchronize();
	declare virtual MenuToggleEditable();
	// tools
	declare virtual MenuNamespacesWalker();
	// windows
	declare virtual MenuCloseBrowser();
	// helpers
	declare OnLastBrowserRemoved();
	declare MenuTextSize(int value); // helper for MenuTextSize
	declare GetBodyElement3(IWebBrowser2 *webbrowser, IHTMLElement3 *ppv),HRESULT;
	declare EnableMenuByOLECMDID(IWebBrowser2 *webbrowser, OLECMDID cmdID, int MenuId);
	declare EnableMenuByHtmlDispId(IWebBrowser2 *webbrowser, OLECMDID cmdID, int MenuId);
	declare EnableMenuByOLECMDF(int MenuId, OLECMDF state);
	declare ShowPreferences();

	HWND   m_hwndStatus;
	HMENU  m_TrayMenu;
	HMENU  m_AppMenu;

	CWorkerTopics  m_wTopics;
	CWorkerBrowser m_wBrowser;
	CDropTarget    m_dragdrop;
	// hook
	CHookList      m_hooks;
}

class RECT
{
	declare Width(),int;
	declare Height(),int;
}


/*
sub CUtil
*/
class CUtil // only static methods
{
	// copy as much characters to pszOut, that will fit MaxWidth pixels
	declare CropText(HWND hwnd, TCHAR *pszIn, TCHAR *pszOut, int MaxWidth);
	// pdcGray receives new HDC; pbmGray receives previous HBITMAP from pdcGray
	declare CreateGrayImage24(HDC dc, COLORREF *pColorMask, HDC *pdcGray, HBITMAP *pbmGray);
}


/*
sub CTab
*/
class CTab : CControlBase
{
	declare Initialize(HWND hwnd);
	// this methods creates and manages extra 'close topic' button on the tab control
	declare WndProc(UINT uMsg,WPARAM wParam,LPARAM lParam),LRESULT;
	// returns mouse position, rectangle of close button
	// the return value is true if the mouse is over close button
	declare GetDrawRect(POINT *pt, RECT *rc),BOOL;
	// draws the close button; for 'state' values see DrawFrameControl
	declare DrawCloseButton(RECT *rc, DWORD state);

	declare ItemCount(),int;
	declare GetCurSel(),int;
	declare DeleteItem(int index);
	declare GetBrowser(int index, CDispBrowser *ppv),BOOL;
	declare AddBrowser(CDispBrowser *browser);
	declare SetText(int index, LPTSTR text);
	declare ItemFromPoint(POINT *pt),int;
	declare SetSel(int index);
	declare ItemRect(int index,RECT *rc),BOOL;
	declare IsVisible(),BOOL;

	DWORD   m_state;
	WNDPROC m_tabwndproc;
}



/*
sub CTolbar
*/
class CTolbar : CControlBase
{
	declare Initialize(HWND hwndWorker, LPTSTR ResourceBitmapId);
	declare Cleanup();
	declare Paint(NMTBCUSTOMDRAW *nmtbcd);
	declare EnableButton(int id, BOOL enable);
	declare OnResized(int cx,int cy);
	
	HWND     m_hwndAddress;
	HWND     m_hwndAddressEdit;
	HWND     m_hwndGo;
	COLORREF m_ColorMask;
	HDC      m_dcNormal;
	HBITMAP  m_bmNormal;
	HDC      m_dcGray;
	HBITMAP  m_bmGray;
}

