#ifndef __MSHelpControls_inc__
#define __MSHelpControls_inc__

#ifndef __objbase_inc__
#include "objbase.inc"
#endif

// Library MSHelpControls
// Doc: Microsoft Help Visuals 1.0
// InprocServer32: c:\Program Files\Gemeinsame Dateien\Microsoft Shared\Help\hxvz.dll
// ProgID: HxVz.HxTocCtrl.1	clsid: {314111B8-A502-11D2-BBCA-00C04F8EC294}
// ProgID: HxVz.HxIndexCtrl.1	clsid: {314111C6-A502-11D2-BBCA-00C04F8EC294}

//#use "ocx\\vshelp.lib"

enum HxTreeLineStyleConstant
{
	HxTreeLineStyle_TreeLines = 0,
	HxTreeLineStyle_RootLines = 1
}

enum HxTreeStyleConstant
{
	HxTreeStyle_TextOnly = 0,
	HxTreeStyle_PictureText = 1,
	HxTreeStyle_PlusMinusText = 2,
	HxTreeStyle_PlusPictureText = 3,
	HxTreeStyle_TreelinesText = 4,
	HxTreeStyle_TreelinesPictureText = 5,
	HxTreeStyle_TreelinesPlusMinusText = 6,
	HxTreeStyle_TreelinesPlusMinusPictureText = 7
}

enum HxBorderStyle
{
	HxBorderStyle_None = 0,
	HxBorderStyle_FixedSingle = 1
}

enum HxAppearanceConstant
{
	HxAppearance_Flat = 0,
	HxAppearance_3D = 1
}

enum HxMousePointerConstant
{
	HxMousePointer_Default = 0,
	HxMousePointer_Arrow = 1,
	HxMousePointer_Cross = 2,
	HxMousePointer_IBeam = 3,
	HxMousePointer_Icon = 4,
	HxMousePointer_Size = 5,
	HxMousePointer_SizeNESW = 6,
	HxMousePointer_SizeNS = 7,
	HxMousePointer_SizeNWSE = 8,
	HxMousePointer_SizeEW = 9,
	HxMousePointer_UpArrow = 10,
	HxMousePointer_Hourglass = 11,
	HxMousePointer_NoDrop = 12,
	HxMousePointer_ArrowHourglass = 13,
	HxMousePointer_ArrowQuestion = 14,
	HxMousePointer_SizeAll = 15,
	HxMousePointer_Custom = 99
}

enum HxFontSourceConstant
{
	HxFontCollection = 0,
	HxFontExternal = 1
}

// {314111BB-A502-11D2-BBCA-00C04F8EC294}
extern _DIID_IHxTreeViewEvents as GUID;

interface IHxTreeViewEvents : IDispatch // [dispatchable]
{
	declare virtual NodeClick(long hNode),HRESULT;
	declare virtual NodeRightClick(long hNode, long x, long y),HRESULT;
}


// {314111DF-A502-11D2-BBCA-00C04F8EC294}
extern _DIID_IHxIndexViewEvents as GUID;

interface IHxIndexViewEvents : IDispatch // [dispatchable]
{
	declare virtual ItemClick(/*[in]*/long iItem),HRESULT;
	declare virtual ItemSelect(/*[in]*/long iItem),HRESULT;
}


// {314111B8-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxTocCtrl as GUID; // [cancreate]
// interface IHxTreeView
// dispinterface IHxTreeViewEvents

// {314111B9-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxTreeView as GUID;

interface IHxTreeView : IDispatch // [dispatchable][nonextensible][dual][hidden]
{
	declare virtual get_Hierarchy(IHxHierarchy* ppRetval),HRESULT;
	declare virtual put_Hierarchy(/*[in]*/IHxHierarchy* rhs),HRESULT;
	declare virtual put_ImageList(/*[in]*/long rhs),HRESULT;
	declare virtual get_ImageList(long* ppRetval),HRESULT;
	declare virtual get_HideSelection(VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual put_HideSelection(/*[in]*/VARIANT_BOOL rhs),HRESULT;
	declare virtual get_LineStyle(HxTreeLineStyleConstant* ppRetval),HRESULT;
	declare virtual put_LineStyle(/*[in]*/HxTreeLineStyleConstant rhs),HRESULT;
	declare virtual get_TreeStyle(HxTreeStyleConstant* ppRetval),HRESULT;
	declare virtual put_TreeStyle(/*[in]*/HxTreeStyleConstant rhs),HRESULT;
	declare virtual put_BackColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_BackColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_ForeColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_ForeColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_BorderStyle(/*[in]*/HxBorderStyle rhs),HRESULT;
	declare virtual get_BorderStyle(HxBorderStyle* ppRetval),HRESULT;
	declare virtual put_Appearance(/*[in]*/HxAppearanceConstant rhs),HRESULT;
	declare virtual get_Appearance(HxAppearanceConstant* ppRetval),HRESULT;
	declare virtual put_MousePointer(/*[in]*/HxMousePointerConstant rhs),HRESULT;
	declare virtual get_MousePointer(HxMousePointerConstant* ppRetval),HRESULT;
	declare virtual Refresh(),HRESULT;
	declare virtual put_Font(/*[in]*/Font* rhs),HRESULT;
	declare virtual putref_Font(/*[in]*/Font* rhs),HRESULT;
	declare virtual get_Font(Font* ppRetval),HRESULT;
	declare virtual Synchronize(/*[in]*/BSTR bstrURL),HRESULT;
	// Get the currently selected node
	declare virtual get_Selection(long* ppRetval),HRESULT;
	declare virtual get_LangId(short* ppRetval),HRESULT;
	declare virtual put_LangId(/*[in]*/short rhs),HRESULT;
	declare virtual get_FontSource(HxFontSourceConstant* ppRetval),HRESULT;
	declare virtual put_FontSource(/*[in]*/HxFontSourceConstant rhs),HRESULT;
}


// {314111C6-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxIndexCtrl as GUID; // [cancreate]
// interface IHxIndexView
// dispinterface IHxIndexViewEvents

// {314111C4-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxIndexView as GUID;

interface IHxIndexView : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_IndexData(IHxIndex* ppRetval),HRESULT;
	declare virtual put_IndexData(/*[in]*/IHxIndex* rhs),HRESULT;
	declare virtual put_Selection(/*[in]*/long rhs),HRESULT;
	declare virtual get_Selection(long* ppRetval),HRESULT;
	declare virtual put_BackColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_BackColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_ForeColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_ForeColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_BorderStyle(/*[in]*/HxBorderStyle rhs),HRESULT;
	declare virtual get_BorderStyle(HxBorderStyle* ppRetval),HRESULT;
	declare virtual put_Appearance(/*[in]*/HxAppearanceConstant rhs),HRESULT;
	declare virtual get_Appearance(HxAppearanceConstant* ppRetval),HRESULT;
	declare virtual put_MousePointer(/*[in]*/HxMousePointerConstant rhs),HRESULT;
	declare virtual get_MousePointer(HxMousePointerConstant* ppRetval),HRESULT;
	declare virtual SelectItem(/*[in]*/long iItem),HRESULT;
	declare virtual ClickItem(/*[in]*/long iItem),HRESULT;
	declare virtual Refresh(),HRESULT;
	declare virtual put_Font(/*[in]*/Font* rhs),HRESULT;
	declare virtual putref_Font(/*[in]*/Font* rhs),HRESULT;
	declare virtual get_Font(Font* ppRetval),HRESULT;
	declare virtual put_HighlightForeColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_HighlightForeColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_HighlightBackColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_HighlightBackColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_FocusHighlightForeColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_FocusHighlightForeColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual put_FocusHighlightBackColor(/*[in]*/OLE_COLOR rhs),HRESULT;
	declare virtual get_FocusHighlightBackColor(OLE_COLOR* ppRetval),HRESULT;
	declare virtual get_LangId(short* ppRetval),HRESULT;
	declare virtual put_LangId(/*[in]*/short rhs),HRESULT;
	declare virtual get_FontSource(HxFontSourceConstant* ppRetval),HRESULT;
	declare virtual put_FontSource(/*[in]*/HxFontSourceConstant rhs),HRESULT;
}


#endif
