#ifndef __MSHelpServices_inc__
#define __MSHelpServices_inc__

#ifndef __objbase_inc__
#include "objbase.inc"
#endif

//#use "ocx\\vshelp.lib"

// Library MSHelpServices
// Doc: Microsoft Help Data Services 1.0 Type Library
// InprocServer32: c:\Program Files\Gemeinsame Dateien\Microsoft Shared\Help\hxds.dll
// ProgID: HxDS.HxRegisterSession.1	clsid: {31411219-A502-11D2-BBCA-00C04F8EC294}
// ProgID: HxDS.HxRegisterProtocol.1	clsid: {31411228-A502-11D2-BBCA-00C04F8EC294}
// ProgID: HxDs.HxRegistryWalker.1	clsid: {314111F0-A502-11D2-BBCA-00C04F8EC294}
// ProgID: HxDS.HxSession.1	clsid: {31411198-A502-11D2-BBCA-00C04F8EC294}

enum HxHierarchyNodeType
{
	HxHierarchy_Book = 3,
	HxHierarchy_BookPage = 4,
	HxHierarchy_Page = 5,
	HxHierarchy_Unknown = 8
}

enum HxHierarchyPropId
{
	HxHierarchyTocFont = 0,
	HxHierarchyTocFontSize = 1,
	HxHierarchyTocLangId = 2,
	HxHierarchyTocCharSet = 3,
	HxHierarchyTocId = 4,
	HxHierarchyTocFileVer = 5,
	HxHierarchyTocIconFile = 6,
	HxHierarchyTocParentNodeIcon = 7,
	HxHierarchyTocIcon = 8
}

enum HxTopicGetTitleType
{
	HxTopicGetTOCTitle = 0,
	HxTopicGetRLTitle = 1,
	HxTopicGetHTMTitle = 2
}

enum HxTopicGetTitleDefVal
{
	HxTopicGetTitleFullURL = 0,
	HxTopicGetTitleFileName = 1,
	HxTopicGetTitleNoDefault = 2
}

enum HxQueryPropId
{
	HxPropIdQueryFirst = 0
}

enum HxTopicPropId
{
	HxTopicPropIdFirst = 0
}

enum HxHierarchy_PrintNode_Options
{
	HxHierarchy_PrintNode_Option_Node = 0,
	HxHierarchy_PrintNode_Option_Children = 1
}

enum HxQuery_Options
{
	HxQuery_No_Option = 0,
	HxQuery_FullTextSearch_Title_Only = 1,
	HxQuery_FullTextSearch_Enable_Stemming = 2,
	HxQuery_FullTextSearch_SearchPrevious = 4,
	HxQuery_KeywordSearch_CaseSensitive = 10,
	HxQuery_KeywordSearch_AllowDuplicates = 16,
	HxQuery_FullTextSearch_Wildcard_Preserve = 128,
	HxQuery_FullTextSearch_ReturnRanking = 256,
	HxQuery_FullTextSearch_MinImprovements = 512
}

enum HxCollectionPropId
{
	HxCollectionProp_NamespaceName = 1,
	HxCollectionProp_Font = 2,
	HxCollectionProp_FontSize = 3,
	HxCollectionProp_LangId = 4,
	HxCollectionProp_CharSet = 5,
	HxCollectionProp_Id = 6,
	HxCollectionProp_FileVer = 7,
	HxCollectionProp_CopyRight = 8
}

enum HxRegFilterPropId
{
	HxRegFilterName = 0,
	HxRegFilterQuery = 1
}

enum HxIndexPropId
{
	HxIndexFont = 0,
	HxIndexFontSize = 1,
	HxIndexLangId = 2,
	HxIndexCharSet = 3,
	HxIndexTitleStr = 4,
	HxIndexIsVisible = 5,
	HxIndexId = 6
}

enum HxSampleFileCopyOption
{
	HxSampleFileCopyNoOption = 0,
	HxSampleFileCopyOverwrite = 1,
	HxSampleFileCopyFileOnly = 2
}

enum HxRegNamespacePropId
{
	HxRegNamespaceTitleList = 0,
	HxRegNamespacePlugInList = 1,
	HxRegNamespaceName = 2,
	HxRegNamespaceCollection = 3,
	HxRegNamespaceDescription = 4,
	HxRegNamespaceFilterList = 8
}

enum HxRegTitlePropId
{
	HxRegTitleFileName = 0,
	HxRegTitleIndexName = 1,
	HxRegTitleQueryName = 2,
	HxRegTitleId = 3,
	HxRegTitleLangId = 4,
	HxRegAttrQueryName = 5,
	HxRegTitleHxsMediaLoc = 6,
	HxRegTitleHxqMediaLoc = 7,
	HxRegTitleHxrMediaLoc = 8,
	HxRegTitleSampleMediaLoc = 9
}

enum HxRegPlugInPropId
{
	HxRegPlugInName = 0
}

enum HxRegisterSession_InterfaceType
{
	HxRegisterSession_IHxRegister = 0,
	HxRegisterSession_IHxFilters = 1,
	HxRegisterSession_IHxPlugIn = 2
}

enum HxCancelStatus
{
	HxCancelStatus_Continue = 0,
	HxCancelStatus_Cancel = 1
}

// {314111B2-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxHierarchy as GUID;

interface IHxHierarchy : IDispatch // [dispatchable][nonextensible][dual]
{
	// (IHxSession*)->GetNavigationObject(L"!DefaultToc", L"", &(IDispatch*))
	// (IDispatch*)->QueryInterface(_IID_IHxHierarchy, &toc)
	declare virtual GetRoot(long* ppRetval),HRESULT;
	declare virtual GetParent(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual GetSibling(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual GetFirstChild(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual GetNextFromUrl(/*[in]*/BSTR pURL, long* ppRetval),HRESULT;
	declare virtual GetPrevFromUrl(/*[in]*/BSTR pURL, long* ppRetval),HRESULT;
	declare virtual GetType(/*[in]*/long hNode, HxHierarchyNodeType* ppRetval),HRESULT;
	declare virtual IsNew(/*[in]*/long hNode, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual HasChild(/*[in]*/long hNode, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual GetSyncInfo(/*[in]*/BSTR pURL, SAFEARRAY/*VARIANT*/* ppRetval),HRESULT;
	declare virtual GetTitle(/*[in]*/long hNode, BSTR* ppRetval),HRESULT;
	declare virtual GetImageIndexes(/*[in]*/long hNode, /*[out]*/long* pOpen, long* ppRetval),HRESULT;
	declare virtual GetURL(/*[in]*/long hNode, BSTR* ppRetval),HRESULT;
	declare virtual OnNavigation(/*[in]*/BSTR pbstrURL, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual OnHierarchyNavigation(/*[in]*/long hNode),HRESULT;
	declare virtual GetProperty(/*[in]*/HxHierarchyPropId propid, /*[in]*/long hNode, VARIANT* ppRetval),HRESULT;
	declare virtual GetNextFromNode(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual GetPrevFromNode(/*[in]*/long hNode, long* ppRetval),HRESULT;
	// if GetTopic fails, try GetURL
	declare virtual GetTopic(/*[in]*/long hNode, IHxTopic* ppRetval),HRESULT;
	declare virtual GetOpenImageIndex(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual GetClosedImageIndex(/*[in]*/long hNode, long* ppRetval),HRESULT;
	declare virtual PrintNode(/*[in]*/long hwnd, /*[in]*/long hNode, /*[in]*/HxHierarchy_PrintNode_Options options),HRESULT;
}


// {31411196-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxTopic as GUID;

interface IHxTopic : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_Title(/*[in]*/HxTopicGetTitleType optType, /*[in]*/HxTopicGetTitleDefVal optDef, BSTR* ppRetval),HRESULT;
	declare virtual get_URL(BSTR* ppRetval),HRESULT;
	declare virtual get_Location(BSTR* ppRetval),HRESULT;
	declare virtual get_Rank(long* ppRetval),HRESULT;
	declare virtual get_Attributes(IHxAttributeList* ppRetval),HRESULT;
	declare virtual GetInfo(/*[out]*/BSTR* pTitle, /*[out]*/BSTR* pURL, /*[out]*/BSTR* pLocation, /*[out]*/long* pRank),HRESULT;
	declare virtual GetProperty(/*[in]*/HxTopicPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual SetProperty(/*[in]*/HxTopicPropId propid, /*[in]*/VARIANT var byval),HRESULT;
	declare virtual HasAttribute(/*[in]*/BSTR Name, /*[in]*/BSTR Value, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual HasAttrName(/*[in]*/BSTR Name, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual HighlightDocument(/*[in]*/IDispatch* pIDispatch),HRESULT;
}


// {314111AB-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttributeList as GUID;

interface IHxAttributeList : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxAttribute* ppRetval),HRESULT;
	declare virtual EnumAttribute(/*[in]*/long filter, /*[in]*/long options, IEnumHxAttribute* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual Item(/*[in]*/VARIANT index byval, IHxAttribute* ppRetval),HRESULT;
}


// {314111A9-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttribute as GUID;

interface IHxAttribute : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxQueryPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual SetProperty(/*[in]*/HxQueryPropId propid, /*[in]*/VARIANT var byval),HRESULT;
	declare virtual get_Name(BSTR* ppRetval),HRESULT;
	declare virtual get_Value(BSTR* ppRetval),HRESULT;
	declare virtual get_DisplayName(BSTR* ppRetval),HRESULT;
	declare virtual get_DisplayValue(BSTR* ppRetval),HRESULT;
}


// {314111AD-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxAttribute as GUID;

interface IEnumHxAttribute : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxAttribute*  ppIHxAttribute, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxAttribute*  ppEnum),HRESULT;
}


// {314111BC-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegister as GUID;

interface IHxRegister : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual RegisterNamespace(/*[in]*/BSTR bstrNamespace, /*[in]*/BSTR bstrCollection, /*[in]*/BSTR bstrDescription),HRESULT;
	declare virtual IsNamespace(/*[in]*/BSTR bstrNamespace, VARIANT_BOOL* ppRetval),HRESULT;
	declare virtual GetCollection(/*[in]*/BSTR bstrNamespace, BSTR* ppRetval),HRESULT;
	declare virtual GetDescription(/*[in]*/BSTR bstrNamespace, BSTR* ppRetval),HRESULT;
	declare virtual RemoveNamespace(/*[in]*/BSTR bstrNamespace),HRESULT;
	declare virtual RegisterHelpFile(/*[in]*/BSTR bstrNamespace, /*[in]*/BSTR bstrId, /*[in]*/long LangId, /*[in]*/BSTR bstrHelpFile),HRESULT;
	declare virtual RegisterMedia(/*[in]*/BSTR bstrNamespace, /*[in]*/BSTR bstrFriendly, /*[in]*/BSTR bstrPath, long* ppRetval),HRESULT;
	declare virtual RemoveHelpFile(/*[in]*/BSTR bstrNamespace, /*[in]*/BSTR bstrId, /*[in]*/long LangId),HRESULT;
	declare virtual RegisterHelpFileSet(/*[in]*/BSTR bstrNamespace, /*[in]*/BSTR bstrId, /*[in]*/long LangId, /*[in]*/BSTR bstrHxs, /*[in]*/BSTR bstrHxi, /*[in]*/BSTR bstrHxq, /*[in]*/BSTR bstrHxr, /*[in]*/long lHxsMediaId, /*[in]*/long lHxqMediaId, /*[in]*/long lHxrMediaId, /*[in]*/long lSampleMediaId),HRESULT;
}


// {314111CC-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxIndex as GUID;

interface IHxIndex : IDispatch // [dispatchable][nonextensible][dual]
{
	// (IHxSession*)->GetNavigationObject(L"!DefaultKeywordIndex", L"", &(IDispatch*))
	// (IDispatch*)->QueryInterface(_IID_IHxIndex, &(IHxIndex*))
	declare virtual GetSession(IHxSession* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual GetStringFromSlot(/*[in]*/long iSlot, BSTR* ppRetval),HRESULT;
	declare virtual GetLevelFromSlot(/*[in]*/long iSlot, long* ppRetval),HRESULT;
	declare virtual GetSlotFromString(/*[in]*/BSTR bszLink, long* ppRetval),HRESULT;
	declare virtual GetTopicsFromSlot(/*[in]*/long uiSlot, IHxTopicList* ppRetval),HRESULT;
	declare virtual GetTopicsFromString(/*[in]*/BSTR bszLink, /*[in]*/long options, IHxTopicList* ppRetval),HRESULT;
	declare virtual GetInfoFromSlot(/*[in]*/long iSlot, /*[out]*/long* piLevel, BSTR* ppRetval),HRESULT;
	declare virtual GetProperty(/*[in]*/HxIndexPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual GetCrossRef(/*[in]*/long iSlot, BSTR* ppRetval),HRESULT;
	declare virtual GetFullStringFromSlot(/*[in]*/long iSlot, /*[in]*/BSTR sep, BSTR* ppRetval),HRESULT;
	declare virtual GetCrossRefSlot(/*[in]*/long iSlot, long* ppRetval),HRESULT;
}


// {31411192-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxSession as GUID; // CoCreateInstance(_CLSID_HxSession, 0, 1, _IID_IHxSession, &session)

interface IHxSession : IDispatch // [dispatchable][nonextensible][dual][hidden]
{
	declare virtual Initialize(/*[in]*/BSTR NameSpace, /*[in]*/long options),HRESULT;
	declare virtual Query(/*[in]*/BSTR keywords, /*[in]*/BSTR NavDataMoniker, /*[in]*/long options, /*[in]*/BSTR FilterMoniker, IHxTopicList* ppRetval),HRESULT;
	declare virtual QueryForTopic(/*[in]*/BSTR keywords, /*[in]*/BSTR NavDataMoniker, /*[in]*/long options, /*[in]*/BSTR FilterMoniker, IHxTopic* ppRetval),HRESULT;
	declare virtual QueryForUrl(/*[in]*/BSTR keywords, /*[in]*/BSTR NavDataMoniker, /*[in]*/long options, /*[in]*/BSTR FilterMoniker, BSTR* ppRetval),HRESULT;
	declare virtual GetNavigationInterface(/*[in]*/BSTR NavDataMoniker, /*[in]*/BSTR FilterMoniker, /*[in]*/GUID* refiid, IDispatch* ppRetval),HRESULT;
	declare virtual GetNavigationObject(/*[in]*/BSTR NavDataMoniker, /*[in]*/BSTR FilterMoniker, IDispatch* ppRetval),HRESULT;
	declare virtual GetQueryObject(/*[in]*/BSTR NavDataMoniker, /*[in]*/BSTR FilterMoniker, IHxQuery* ppRetval),HRESULT;
	declare virtual get_Collection(IHxCollection* ppRetval),HRESULT;
	declare virtual get_LangId(short* ppRetval),HRESULT;
	declare virtual put_LangId(/*[in]*/short rhs),HRESULT;
	declare virtual GetFilterList(IHxRegFilterList* ppRetval),HRESULT;
}


// {31411194-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxTopicList as GUID;

interface IHxTopicList : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Item(/*[in]*/VARIANT index byval, IHxTopic* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxTopic* ppRetval),HRESULT;
	declare virtual EnumTopics(/*[in]*/long filter, /*[in]*/long options, IEnumHxTopic* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
}


// {31411195-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxTopic as GUID;

interface IEnumHxTopic : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxTopic*  ppIHxTopic, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxTopic*  ppEnum),HRESULT;
}


// {31411193-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxQuery as GUID;

interface IHxQuery : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Query(/*[in]*/BSTR keywords, /*[in]*/HxQuery_Options options, IHxTopicList* ppRetval),HRESULT;
	declare virtual QueryForTopic(/*[in]*/BSTR keywords, /*[in]*/HxQuery_Options options, IHxTopic* ppRetval),HRESULT;
	declare virtual QueryForUrl(/*[in]*/BSTR keywords, /*[in]*/HxQuery_Options options, BSTR* ppRetval),HRESULT;
}


// {314111A1-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxCollection as GUID;

interface IHxCollection : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxCollectionPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual SetProperty(/*[in]*/HxCollectionPropId propid, /*[in]*/VARIANT var byval),HRESULT;
	declare virtual get_URL(BSTR* ppRetval),HRESULT;
	declare virtual get_AttributeNames(IHxAttrNameList* ppRetval),HRESULT;
	declare virtual get_Filters(IHxFilters* ppRetval),HRESULT;
	declare virtual get_Title(BSTR* ppRetval),HRESULT;
	declare virtual MergeIndex(),HRESULT;
	declare virtual GetFilterTopicCount(/*[in]*/BSTR bstrQuery, long* ppRetval),HRESULT;
}


// {314111CE-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttrNameList as GUID;

interface IHxAttrNameList : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxAttrName* ppRetval),HRESULT;
	declare virtual EnumAttrName(/*[in]*/long filter, /*[in]*/long options, IEnumHxAttrName* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual Item(/*[in]*/VARIANT index byval, IHxAttrName* ppRetval),HRESULT;
}


// {314111D2-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttrName as GUID;

interface IHxAttrName : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxQueryPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual SetProperty(/*[in]*/HxQueryPropId propid, /*[in]*/VARIANT var byval),HRESULT;
	declare virtual get_Name(BSTR* ppRetval),HRESULT;
	declare virtual get_DisplayName(BSTR* ppRetval),HRESULT;
	declare virtual get_Flag(long* ppRetval),HRESULT;
	declare virtual get_AttributeValues(IHxAttrValueList* ppRetval),HRESULT;
}


// {314111D4-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttrValueList as GUID;

interface IHxAttrValueList : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxAttrValue* ppRetval),HRESULT;
	declare virtual EnumAttrValue(/*[in]*/long filter, /*[in]*/long options, IEnumHxAttrValue* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual Item(/*[in]*/VARIANT index byval, IHxAttrValue* ppRetval),HRESULT;
}


// {314111D8-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxAttrValue as GUID;

interface IHxAttrValue : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxQueryPropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual SetProperty(/*[in]*/HxQueryPropId propid, /*[in]*/VARIANT var byval),HRESULT;
	declare virtual get_Value(BSTR* ppRetval),HRESULT;
	declare virtual get_DisplayValue(BSTR* ppRetval),HRESULT;
	declare virtual get_Flag(long* ppRetval),HRESULT;
}


// {314111D6-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxAttrValue as GUID;

interface IEnumHxAttrValue : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxAttrValue*  ppIHxAttrValue, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxAttrValue*  ppEnum),HRESULT;
}


// {314111D0-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxAttrName as GUID;

interface IEnumHxAttrName : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxAttrName*  ppIHxAttrName, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxAttrName*  ppEnum),HRESULT;
}


// {314111E3-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxFilters as GUID;

interface IHxFilters : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Count(long* ppRetval),HRESULT;
	declare virtual GetFilter(/*[in]*/long iIndex, /*[out]*/BSTR* pbstrName, BSTR* ppRetval),HRESULT;
	declare virtual GetFilterName(/*[in]*/long iIndex, BSTR* ppRetval),HRESULT;
	declare virtual GetFilterQuery(/*[in]*/long iIndex, BSTR* ppRetval),HRESULT;
	declare virtual RegisterFilter(/*[in]*/BSTR bstrName, /*[in]*/BSTR bstrQuery),HRESULT;
	declare virtual RemoveFilter(/*[in]*/BSTR bstrName),HRESULT;
	declare virtual FindFilter(/*[in]*/BSTR bstrName, BSTR* ppRetval),HRESULT;
	declare virtual SetNamespace(/*[in]*/BSTR bstrName),HRESULT;
	declare virtual SetCollectionFiltersFlag(/*[in]*/VARIANT_BOOL vb),HRESULT;
}


// {31411212-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegFilterList as GUID;

interface IHxRegFilterList : IDispatch // [dispatchable][nonextensible][dual]
{
	// (IHxRegNamespace*)->GetProperty(HxRegNamespaceFilterList, &variant)
	// variant.pUnkVal->QueryInterface(_IID_IHxRegFilterList, &(IHxRegFilterList*))
	declare virtual Item(/*[in]*/VARIANT index byval, IHxRegFilter* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxRegFilter* ppRetval),HRESULT;
	declare virtual EnumRegFilter(/*[in]*/long filter, /*[in]*/long options, IEnumHxRegFilter* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
	declare virtual FindFilter(/*[in]*/BSTR bstrFilterName, IHxRegFilter* ppRetval),HRESULT;
}


// {31411221-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegFilter as GUID;

interface IHxRegFilter : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxRegFilterPropId propid, VARIANT* ppRetval),HRESULT;
}


// {3141121C-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxRegFilter as GUID;

interface IEnumHxRegFilter : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxRegFilter*  ppIHxRegFilter, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxRegFilter*  ppEnum),HRESULT;
}


// {314111E6-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxSampleCollection as GUID;

interface IHxSampleCollection : IDispatch // [dispatchable][nonextensible][dual]
{
	// Get a Sample from the collection based on the SampleId
	declare virtual GetSampleFromId(/*[in]*/BSTR bstrTopicUrl, /*[in]*/BSTR bstrId, /*[in]*/BSTR bstrSFLName, IHxSample* ppRetval),HRESULT;
}


// {314111E8-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxSample as GUID;

interface IHxSample : IDispatch // [dispatchable][nonextensible][dual]
{
	// The SampleId for this Sample
	declare virtual get_SampleId(BSTR* ppRetval),HRESULT;
	// The string to display when loading the Sample
	declare virtual get_LoadString(BSTR* ppRetval),HRESULT;
	// The default destination directory for the Sample
	declare virtual get_DestinationDir(BSTR* ppRetval),HRESULT;
	// The project extension for the Sample
	declare virtual get_ProjectFileExt(BSTR* ppRetval),HRESULT;
	// The count of files in this Sample
	declare virtual get_FileCount(long* ppRetval),HRESULT;
	// Get the file name for the file at the specified index
	declare virtual GetFileNameAtIndex(/*[in]*/long index, BSTR* ppRetval),HRESULT;
	// Copy the file at the given index
	declare virtual CopyFileAtIndex(/*[in]*/long index, /*[in]*/BSTR bstrDest, /*[in]*/HxSampleFileCopyOption option),HRESULT;
	// Show the Choose Directory common dialog
	declare virtual ChooseDirectory(/*[in]*/BSTR bstrDefaultDir, /*[in]*/BSTR bstrTitle, BSTR* ppRetval),HRESULT;
	// Return the contents of a text file
	declare virtual GetFileTextAtIndex(/*[in]*/long index, BSTR* ppRetval),HRESULT;
}


// {314111EF-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegistryWalker as GUID; // CoCreateInstance(_CLSID_HxRegistryWalker, 0, 1, _IID_IHxRegistryWalker, &g_hxwalker)

interface IHxRegistryWalker : IDispatch // [dispatchable][nonextensible][dual]
{
	// Get a list of all registered namespaces
	declare virtual get_RegisteredNamespaceList(/*[in]*/BSTR bstrStart, IHxRegNamespaceList* ppRetval),HRESULT;
}


// {314111F3-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegNamespaceList as GUID;

interface IHxRegNamespaceList : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Item(/*[in]*/VARIANT index byval, IHxRegNamespace* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxRegNamespace* ppRetval),HRESULT;
	declare virtual EnumRegNamespace(/*[in]*/long filter, /*[in]*/long options, IEnumHxRegNamespace* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
}


// {314111F1-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegNamespace as GUID;

interface IHxRegNamespace : IDispatch // [dispatchable][nonextensible][dual]
{
	// Get the name of this registered namespace
	declare virtual get_Name(BSTR* ppRetval),HRESULT;
	declare virtual GetProperty(/*[in]*/HxRegNamespacePropId propid, VARIANT* ppRetval),HRESULT;
	declare virtual IsTitle(/*[in]*/BSTR bstrTitle, VARIANT_BOOL* ppRetval),HRESULT;
}


// {314111F5-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxRegNamespace as GUID;

interface IEnumHxRegNamespace : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxRegNamespace*  ppIHxRegNamespace, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxRegNamespace*  ppEnum),HRESULT;
}


// {31411202-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegTitle as GUID;

interface IHxRegTitle : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxRegTitlePropId propid, VARIANT* ppRetval),HRESULT;
}


// {31411203-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegTitleList as GUID;

interface IHxRegTitleList : IDispatch // [dispatchable][nonextensible][dual]
{
	// (IHxRegNamespace*)->GetProperty(HxRegNamespaceTitleList, &variant)
	// variant.pUnkVal->QueryInterface(_IID_IHxRegTitleList, &(IHxRegTitleList*))
	declare virtual Item(/*[in]*/VARIANT index byval, IHxRegTitle* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxRegTitle* ppRetval),HRESULT;
	declare virtual EnumRegTitle(/*[in]*/long filter, /*[in]*/long options, IEnumHxRegTitle* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
}


// {31411204-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxRegTitle as GUID;

interface IEnumHxRegTitle : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxRegTitle*  ppIHxRegTitle, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxRegTitle*  ppEnum),HRESULT;
}


// {3141120A-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegPlugIn as GUID;

interface IHxRegPlugIn : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual GetProperty(/*[in]*/HxRegPlugInPropId propid, VARIANT* ppRetval),HRESULT;
}


// {3141120B-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegPlugInList as GUID;

interface IHxRegPlugInList : IDispatch // [dispatchable][nonextensible][dual]
{
	// (IHxRegNamespace*)->GetProperty(HxRegNamespacePlugInList, &variant)
	// variant.pUnkVal->QueryInterface(_IID_IHxRegPlugInList, &(IHxRegPlugInList*))
	declare virtual Item(/*[in]*/VARIANT index byval, IHxRegPlugIn* ppRetval),HRESULT;
	declare virtual ItemAt(/*one based*/long index, IHxRegPlugIn* ppRetval),HRESULT;
	declare virtual EnumRegPlugIn(/*[in]*/long filter, /*[in]*/long options, IEnumHxRegPlugIn* ppRetval),HRESULT;
	declare virtual get__NewEnum(IUnknown* ppRetval),HRESULT;
	declare virtual get_Count(long* ppRetval),HRESULT;
}


// {3141120C-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IEnumHxRegPlugIn as GUID;

interface IEnumHxRegPlugIn : IUnknown // [hidden]
{
	declare virtual Next(/*[in]*/ULONG celt, /*[out]*/IHxRegPlugIn*  ppIHxRegPlugIn, /*[out]*/ULONG* pceltFetched),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Skip(/*[in]*/ULONG celt),HRESULT;
	declare virtual Clone(/*[out]*/IEnumHxRegPlugIn*  ppEnum),HRESULT;
}


// {31411218-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegisterSession as GUID; // CoCreateInstance(_CLSID_HxRegisterSession, 0, 1, _IID_IHxRegisterSession, &g_hxregsession)

interface IHxRegisterSession : IDispatch // [dispatchable][nonextensible][dual]
{
	// if CreateTransaction fails, be sure noter app is using it. Check if the following file exists
	// C:\Dokumente und Einstellungen\All Users\Anwendungsdaten\Microsoft Help\Rgstrtn.lck
	// and delete it. If there is a folder, and the files inside it are older than the files
	// in \Microsoft Help\ - replace the newer files and remove folder (folder name is in guid format)
	declare virtual CreateTransaction(/*[in]*/BSTR bstrInToken, BSTR* ppRetval),HRESULT;
	declare virtual PostponeTransaction(BSTR* ppRetval),HRESULT;
	declare virtual ContinueTransaction(/*[in]*/BSTR bstrToken),HRESULT;
	declare virtual CommitTransaction(),HRESULT;
	declare virtual RevertTransaction(),HRESULT;
	declare virtual GetRegistrationObject(/*[in]*/HxRegisterSession_InterfaceType type, IDispatch* ppRetval),HRESULT;
}


// {314111DA-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxPlugIn as GUID;

interface IHxPlugIn : IDispatch // [dispatchable][dual]
{
	// registers another namespace as a plugin for current namespace
	declare virtual RegisterHelpPlugIn(BSTR bstrProductNamespace, BSTR bstrProductHxt, BSTR bstrNamespace, BSTR bstrHxt, BSTR bstrHxa, long options),HRESULT;
	declare virtual RemoveHelpPlugIn(BSTR bstrProductNamespace, BSTR bstrProductHxt, BSTR bstrNamespace, BSTR bstrHxt, BSTR bstrHxa),HRESULT;
}


// {314111AE-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxInitialize as GUID;

interface IHxInitialize : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Initialize(/*[in]*/BSTR InitString, /*[in]*/long options),HRESULT;
	declare virtual get_filter(BSTR* ppRetval),HRESULT;
	declare virtual put_filter(/*[in]*/BSTR rhs),HRESULT;
}


// {31411225-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxCancel as GUID;

interface IHxCancel : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual get_Cancel(HxCancelStatus* ppRetval),HRESULT;
	declare virtual put_Cancel(/*[in]*/HxCancelStatus rhs),HRESULT;
}


// {314111ED-A502-11D2-BBCA-00C04F8EC294}
extern _DIID_IHxSessionEvents as GUID;

interface IHxSessionEvents : IDispatch // [dispatchable]
{
	declare virtual QueryCancel(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status),HRESULT;
	declare virtual IndexMergeStatus(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status),HRESULT;
	declare virtual PrintMergeStatus(/*[in]*/IDispatch* pSession, /*[in]*/IDispatch* pCancel, /*[in]*/long status),HRESULT;
	declare virtual MergeIndexFileName(/*[in]*/IDispatch* pDisp, /*[in]*/BSTR bstrFile),HRESULT;
}


// {31411223-A502-11D2-BBCA-00C04F8EC294}
extern _DIID_IHxRegisterSessionEvents as GUID;

interface IHxRegisterSessionEvents : IDispatch // [dispatchable]
{
	declare virtual FiltersChanged(/*[in]*/IDispatch* pDisp, /*[in]*/VARIANT* pvar),HRESULT;
}


// {31411198-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxSession as GUID; // [cancreate]
// interface IHxSession
// dispinterface IHxSessionEvents

// {314111F0-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxRegistryWalker as GUID; // [cancreate]
// interface IHxRegistryWalker

// {31411219-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxRegisterSession as GUID; // [cancreate]
// interface IHxRegisterSession
// dispinterface IHxRegisterSessionEvents

// {31411228-A502-11D2-BBCA-00C04F8EC294}
extern _CLSID_HxRegisterProtocol as GUID; // [cancreate]
// interface IHxRegisterProtocol

// {31411227-A502-11D2-BBCA-00C04F8EC294}
extern _IID_IHxRegisterProtocol as GUID;

interface IHxRegisterProtocol : IDispatch // [dispatchable][nonextensible][dual]
{
	declare virtual Register(),HRESULT;
	declare virtual Unregister(),HRESULT;
}


//////////////////////////////////
// module HxSearchMeta
#define HxSearchMetaBegin L"[SrchMeta["
#define HxSearchMetaEnd L"]SrchMeta]"
#define HxSearchTocBegin L"[Toc["
#define HxSearchTocEnd L"]Toc]"
#define HxSearchInclBegin L"[Incl["
#define HxSearchInclEnd L"]Incl]"
#define HxSearchExclBegin L"[Excl["
#define HxSearchExclEnd L"]Excl]"

#endif
